//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  WH_CBTtbN֐̎gp
//  GNZ̃tbN
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1101  `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plExcelHookCB;

interface

uses
 Windows, Messages, SysUtils, Classes, Forms, Dialogs;

const
  CBT_DLL_MESSAGE = WM_APP+222;

type
  TplExcelHookReciveCB = class(TComponent)
  private
    { Private declarations }
    hHookLib  : THandle;
    FWindowHandle : HWND;
    procedure WndProc(var Message: TMessage);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property WindowHandle : HWND read FWindowHandle write FWindowHandle;
  end;

implementation

function StartCBTHook(Wnd: HWND; SendMsg: Cardinal): Boolean; stdcall;
  external 'PLHOOKCBTMSG.DLL';
procedure StopCBTHook; stdcall; external 'PLHOOKCBTMSG.DLL';

//=============================================================================
//  Create
//=============================================================================
constructor TplExcelHookReciveCB.Create(AOwner: TComponent);
const
  MSGFLT_ADD = 1;
var
  DLLHandle  : THandle;
  FuncFilter : function (msg: Cardinal; dwFlag: DWORD): BOOL; stdcall;
begin
  inherited;

  hHookLib := 0;
  //bZ[WMp̃EChE쐬
  FWindowHandle := AllocateHWnd(WndProc);

  //UIPI([U[ C^[tFCX̕)Ή
  //̃vOǗҌŎsĂWM_APP+100bZ[W̎M\ɂ
  if CheckWin32Version(6, 0) then begin
    DLLHandle := loadLibrary('user32.dll');
    try
      if DLLHandle > 0 then begin
        @FuncFilter := GetProcAddress(DLLHandle, 'ChangeWindowMessageFilter');
        if @FuncFilter <> nil then begin
          FuncFilter(CBT_DLL_MESSAGE, MSGFLT_ADD);
        end;
      end;
    finally
      FreeLibrary(DLLHandle);
    end;
  end;

  if hHookLib = 0 then begin
    hHookLib := LoadLibrary('PLKHOOKCBTMSG.DLL');
    StartCBTHook(FWindowHandle, CBT_DLL_MESSAGE);
  end;
end;

//=============================================================================
//  Destroy
//=============================================================================
destructor TplExcelHookReciveCB.Destroy;
begin
  //tbNI
  StopCBTHook;
  FreeLibrary(hHookLib);

  //AllocateHWnd gč쐬EBhE
  DeallocateHWnd(FWindowHandle);

  inherited;
end;

//-----------------------------------------------------------------------------
//  EBhEnhEBhENX擾
//  ̃TCYݒStrAllocgp
//-----------------------------------------------------------------------------
function GetWindowClassNameStr(hWindow: HWND): string;
var
  Len    : Integer;
  Buffer : PChar;
begin
  Buffer := StrAlloc(MAX_PATH);
  try
    Len := GetClassName(hWindow, Buffer, StrBufSize(Buffer));
    SetString(Result, Buffer, Len);
  finally
    StrDispose(Buffer);
  end;
end;

//-----------------------------------------------------------------------------
//  EBhEnhEBhẼ^Cg擾
//-----------------------------------------------------------------------------
function GetWindowTitleStr(hWindow: HWND): String;
var
  Len    : Integer;
  Buffer : PChar;
begin
  Result := '';
  Len := GetWindowTextLength(hWindow);
  Buffer := StrAlloc(Len + 1);
  try
    Len := GetWindowText(hWindow, Buffer, StrBufSize(Buffer));
    SetString(Result, Buffer, Len + 1);
  finally
    StrDispose(Buffer);
  end;
end;

//-----------------------------------------------------------------------------
//  EnumChildWindows̃R[obN֐
//  ̃tH[̎qEBhE̗
//-----------------------------------------------------------------------------
function EnumChildWndTestProc(hWindow: hWnd; lPar: PNativeInt):
  Boolean; Stdcall;
const
  FExcelSerchClassName = 'Static';
var
  WndClass : String;
  WndTitle : String;
begin
  Result := True;

  WndClass := GetWindowClassNameStr(hWindow);
  if (CompareText(WndClass, FExcelSerchClassName) = 0) then begin
    WndTitle := GetWindowTitleStr(hWindow);

    //EBhẼeLXg'݊pbN''_E[h'ꍇɏ
    if (Pos('݊pbN', WndTitle) > 0) and
       (Pos('_E[h', WndTitle) > 0) then begin

      //LZ{^IDƏύXƂȂ̂
      //ANZ[^[L[s
      SetForegroundWindow(lPar^);
      keybd_event(Ord('N'), 0, 0, 0);
      keybd_event(Ord('N'), 0, KEYEVENTF_KEYUP, 0);
      //ȏqEBhEKvȂ
      Result := False;
    end;
  end;
end;

//=============================================================================
//  bZ[W̏
//  {NX(R|)̃I[i[̃EBhETuNXvV[W[
//  AllocateHWnd̈Ŏw肵
//=============================================================================
procedure TplExcelHookReciveCB.WndProc(var Message: TMessage);
const
  FExcelDlgWndClass = '#32770';
  FExcelDlgWndText  = 'Microsoft Excel';
var
  TargetWnd : HWND;
  WndClass  : String;
  WndTitle  : String;
begin
  if Message.Msg = CBT_DLL_MESSAGE then begin
    TargetWnd := Message.WParam;

    WndClass := GetWindowClassNameStr(TargetWnd);
    WndTitle := GetWindowTitleStr(TargetWnd);

    if (CompareText(WndClass, FExcelDlgWndClass) = 0) and
       (Pos(UpperCase(FExcelDlgWndText), UpperCase(WndTitle)) > 0) then begin
      //_CAO̎qEBhE
      EnumChildWindows(TargetWnd, @EnumChildWndTestProc, LPARAM(@TargetWnd));
    end;
  end;

  Message.Result := DefWindowProc(FWindowHandle,
                                  Message.Msg,
                                  Message.wParam,
                                  Message.lParam);
end;

end.

